Subject: [PATCH v8 18/19] swiotlb-xen: no need to do execute two bus_to_phys translations in a row

From: [email-masked] (Konrad Rzeszutek Wilk)
Date: Wed, 23 Oct 2013 15:53:35 -0400

On Wed, Oct 23, 2013 at 06:34:13PM +0100, Stefano Stabellini wrote:
> > On Thu, Oct 17, 2013 at 06:43:33PM +0100, Stefano Stabellini wrote:
> > > xen_unmap_single calls xen_bus_to_phys, then passes dev_addr to
> > > is_xen_swiotlb_buffer that calls xen_bus_to_phys again.
> > 
> > It does?
> > 
> > I see it call mfn_to_local_pfn which calls pfn_to_mfn and
> > get_phys_to_machine (which I presume is going to be a slow
> > operation on ARM).
> 
> Yeah, I am trying to reduce the number of pfn_to_mfn and mfn_to_pfn
> translations.
> That said, this patch is not needed to have a fully functional
> swiotlb-xen on arm and I would OK with postponing it.

OK, lets do that as it requires some hard thinking.
> 
> 
> > > xen_bus_to_phys is potentially a slow operation that might involve
> > > walking a tree.
> > > We can avoid calling xen_bus_to_phys twice by removing the
> > > is_xen_swiotlb_buffer call and doing the check directly in
> > > xen_unmap_single using the physical address.
> > > 
> > > Signed-off-by: Stefano Stabellini <[email-masked]>
> > 
> > Have you tested this with a PFN that is in a foreign domain?
> 
> That would be blkback. I only tested blkback on ARM, I'll test on x86
> too.
> 
> 
> > I am bit uncomfortable with this - I recall when developing this
> > that I had hit some odd cases of doing DMA of a page to a guest
> > and it not always working. It was the case of not detecting whether
> > the pfn was foreign or not. Sadly I can't recall the details.
> > 
> > I would think that this problem would also be present with ARM?
> > But perhaps all the new changes in the pfn_to_mfn that had lately
> > been done have fixed this?
> 
> No, because on ARM the guest is autotranslate so the pfn returned by
> mfn_to_pfn is always "local".
> However thanks to the m2p_override now we should get the "local" pfn
> from mfn_to_pfn on x86 too.
> I'll test this case though.

Right, so maybe the pfn_to_mfn_local test is useless nowadays?

> 
> 
> > > ---
> > >  drivers/xen/swiotlb-xen.c |    4 ++--
> > >  1 files changed, 2 insertions(+), 2 deletions(-)
> > > 
> > > diff --git a/drivers/xen/swiotlb-xen.c b/drivers/xen/swiotlb-xen.c
> > > index 4d50058..6d9ca61 100644
> > > --- a/drivers/xen/swiotlb-xen.c
> > > +++ b/drivers/xen/swiotlb-xen.c
> > > @@ -426,8 +426,8 @@ static void xen_unmap_single(struct device *hwdev, dma_addr_t dev_addr,
> > >  
> > >  	xen_dma_unmap_page(hwdev, paddr, size, dir, attrs);
> > >  
> > > -	/* NOTE: We use dev_addr here, not paddr! */
> > > -	if (is_xen_swiotlb_buffer(dev_addr)) {
> > > +	if (paddr >= virt_to_phys(xen_io_tlb_start) &&
> > > +		paddr < virt_to_phys(xen_io_tlb_end)) {
> > >  		swiotlb_tbl_unmap_single(hwdev, paddr, size, dir);
> > >  		return;
> > >  	}
> > > -- 
> > > 1.7.2.5
> > >